local ScriptLoaded = false

addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle
		then
		ScriptLoaded = true
		local B = CBW_Battle 
				
		local InfernoDash = function(mo,doaction)
			
			local player = mo.player
			
			player.actiontext = "Inferno Dash"
			player.actionrings = 20
			player.action2text = nil 
			player.action2rings = 0
			
			if not(B.CanDoAction(player))
				player.actionstate = 0
				return end	
	
			if player.actionstate == 0 
				if doaction == 1 
					player.actionstate = 1
					player.actiontime = 0 
					B.PayRings(player)
				    B.ApplyCooldown(player,TICRATE*3)
				    mo.state = S_PLAY_ROLL
					P_InstaThrust(mo, mo.angle, 35*FRACUNIT)
					if P_IsObjectOnGround(mo)
                    P_MoveOrigin(mo, mo.x, mo.y, mo.z + 5*FRACUNIT)
					end
					
				end
			end
			
			if player.actionstate == 1
				player.actiontime = $+1				
				
				player.drawangle = mo.angle
				
				
				if player.actiontime == 10
					player.actionstate = 0
				end
			end
			
		end 
		
		local PriorityFunc = function(player)
			if player.actionstate == 1 then
				B.SetPriority(player,3,3,nil,1,3,"inferno dash")				
		end
		
		local ExhaustFunc = function(player)
			if player.pflags & PF_STARTDASH
				local maxtime = 5*TICRATE
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
				if player.exhaustmeter <= 0
					player.pflags = $ & ~(PF_STARTDASH|PF_SPINNING)
					player.mo.state = S_PLAY_STND
				end
end
				return true
			end
			return false
		end
		
		local CollideFunc = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			
			if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE)
				or not mo[n1].health
				or not mo[n1].state == S_PLAY_ROLL
				or pain[n1]
				return false
			end
			if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)
				S_StartSound(mo[n1], sfx_lose)
				return true
			end
		end
		
		CBW_Battle.SkinVars["pepper"] = {
			special = InfernoDash,
			func_priority_ext = PriorityFunc,
			func_exhaust = ExhaustFunc,
			func_collide = CollideFunc
		}

	end
end)

addHook("PlayerCanDamage", function(player)
if player.mo
and player.mo.skin == "pepper"
and (player.actionstate == 1)
return true
end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
if inflictor and inflictor.skin == "pepper" and inflictor.player.actionstate == 1 and target and target.player
and not (target.player.powers[pw_shield] & SH_PROTECTFIRE) and not target.player.guard
inflictor.state = S_PLAY_FALL
target.state = S_PLAY_PAIN
target.player.burning = true
target.player.pepperhit1 = true
inflictor.momz = 0
inflictor.momy = 0
inflictor.momx = 0
inflictor.player.pflags = $|PF_NOJUMPDAMAGE|PF_JUMPED
return false
end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
if inflictor and inflictor.skin == "pepper" and inflictor.player.actionstate == 1 and target and target.player
and target.player.powers[pw_shield] & SH_PROTECTFIRE and not target.player.guard
inflictor.state = S_PLAY_FALL
target.state = S_PLAY_PAIN
target.player.pepperhit2 = true
inflictor.momz = 0
inflictor.momy = 0
inflictor.momx = 0
inflictor.player.pflags = $|PF_NOJUMPDAMAGE|PF_JUMPED
return false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and player.mo.skin == "pepper"
and player.actionstate == 1

player.mo.momz = 0
end
end)

addHook ("PlayerThink",function(player)
if player.bmburning == nil then player.bmburning = 0 return end
if player.mo
and player.burning

player.bmburning = $+1
A_BossScream(player.mo, 0, 	MT_FIREBALLTRAIL)
if not (leveltime%35) and player.rings > 0
P_GivePlayerRings(player, -1)
S_StartSound(player.mo, sfx_antiri)
end
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.mo.state == S_PLAY_PAIN)
and player.pepperhit1

player.mo.momz = -10*FRACUNIT
P_Thrust(player.mo, player.mo.angle, -9*FRACUNIT)
player.pepperhit1 = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.mo.state == S_PLAY_PAIN)
and player.pepperhit2

player.mo.momz = 18*FRACUNIT
player.mo.momy = 0
player.mo.momx = 0
player.pepperhit2 = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.powers[pw_shield] & SH_PROTECTFIRE)

player.bmburning = 0
player.burning = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.mo.eflags & MFE_TOUCHWATER)

player.bmburning = 0
player.burning = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.mo.eflags & MFE_UNDERWATER)

player.bmburning = 0
player.burning = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.bmburning == 320)

player.bmburning = 0
player.burning = false
end
end)

addHook ("PlayerThink",function(player)
if player.mo
and (player.playerstate == PST_DEAD)

player.bmburning = 0
player.burning = false
end
end)

addHook("PlayerSpawn",function(player)
player.bmburning = 0
player.burning = false
end)